unit HiControlInfo;

interface

uses Windows,kol,Share,Debug;

type
 THiControlInfo = class(TDebug)
   private
     sControl         : PControl;
     sColor           : TColor;
     sFontSize        : integer;
     sFontColor       : TColor;
     sFontName        : string;
     sFontStyle       : integer;
     sFontCharset     : integer;
     sVisible         : integer;
     sEnabled         : integer;
     sCursor          : integer;
     sAlphaBlendValue : integer;
     sCaption         : string;
     sSubClassName    : string;
   public
     _data_PHandle            : THI_Event;

     _event_onColor           : THI_Event;
     _event_onFontSize        : THI_Event;
     _event_onFontColor       : THI_Event;
     _event_onFontName        : THI_Event;
     _event_onFontStyle       : THI_Event;
     _event_onFontCharset     : THI_Event;
     _event_onVisible         : THI_Event;
     _event_onEnabled         : THI_Event;
     _event_onCursor          : THI_Event;
     _event_onAlphaBlendValue : THI_Event;
     _event_onCaption         : THI_Event;
     _event_onSubClassName    : THI_Event;

     procedure _work_doInfo(var _Data:TData; Index:word);
     procedure _var_Color(var _Data:TData; Index:word);
     procedure _var_FontSize(var _Data:TData; Index:word);
     procedure _var_FontColor(var _Data:TData; Index:word);
     procedure _var_FontName(var _Data:TData; Index:word);
     procedure _var_FontStyle(var _Data:TData; Index:word);
     procedure _var_FontCharset(var _Data:TData; Index:word);
     procedure _var_Visible(var _Data:TData; Index:word);
     procedure _var_Enabled(var _Data:TData; Index:word);
     procedure _var_Cursor(var _Data:TData; Index:word);
     procedure _var_AlphaBlendValue(var _Data:TData; Index:word);
     procedure _var_Caption(var _Data:TData; Index:word);
     procedure _var_SubClassName(var _Data:TData; Index:word);

 end;

implementation

procedure THiControlInfo._work_doInfo;
var   sPoint: integer;
      r: real;
      fs: TFontStyle;
begin
  sPoint := ToIntegerEvent(_data_PHandle);
  if sPoint = 0 then Exit; 
  sControl := PControl(sPoint);

  r := ((sControl.Font.FontHeight * -72) - 36) / ScreenDPI;
  sFontSize := Integer(Trunc(r));
  if Frac(r) > 0 then
    Inc(sFontSize);

  fs := sControl.Font.FontStyle;
  sFontStyle := 0;
  if fsBold in fs then  
    sFontStyle := sFontStyle + 1;
  if fsItalic in fs then
    sFontStyle := sFontStyle + 2;     
  if fsUnderline in fs then
    sFontStyle := sFontStyle + 4;     
  if fsStrikeOut in fs then
    sFontStyle := sFontStyle + 8;   
    
  sFontColor       := Color2RGB(sControl.Font.Color);
  sFontName        := sControl.Font.FontName;
  sFontCharset     := sControl.Font.FontCharset;
  sColor           := Color2RGB(sControl.Color);
  sVisible         := integer(sControl.Visible);
  sEnabled         := integer(sControl.Enabled);
  sCursor          :=  integer(sControl.Cursor);   
  sAlphaBlendValue := sControl.AlphaBlend; 
  sCaption         := sControl.Caption;
  sSubClassName    := sControl.SubClassName;   

  _hi_onEvent(_event_onColor,           sColor);
  _hi_onEvent(_event_onVisible,         sVisible);
  _hi_onEvent(_event_onEnabled,         sEnabled);
  _hi_onEvent(_event_onCaption,         sCaption);  
  _hi_onEvent(_event_onFontSize,        sFontSize);
  _hi_onEvent(_event_onFontColor,       sFontColor);
  _hi_onEvent(_event_onFontName,        sFontName);
  _hi_onEvent(_event_onFontStyle,       sFontStyle);    
  _hi_onEvent(_event_onFontCharset,     sFontCharset);
  _hi_onEvent(_event_onCursor,          sCursor);
  _hi_onEvent(_event_onAlphaBlendValue, sAlphaBlendValue);
  _hi_onEvent(_event_onSubClassName,    sSubClassName);

end;

procedure THiControlInfo._var_Color;
begin
  dtInteger(_Data, sColor);
end;

procedure THiControlInfo._var_FontSize;
begin
  dtInteger(_Data, sFontSize);
end;

procedure THiControlInfo._var_FontColor;
begin
  dtInteger(_Data, sFontColor);
end;

procedure THiControlInfo._var_FontName;
begin
  dtString(_Data, sFontName);
end;

procedure THiControlInfo._var_FontStyle;
begin
  dtInteger(_Data, sFontStyle);
end;

procedure THiControlInfo._var_FontCharset;
begin
  dtInteger(_Data, sFontCharset);
end;

procedure THiControlInfo._var_Visible;
begin
  dtInteger(_Data, sVisible);
end;

procedure THiControlInfo._var_Enabled;
begin
  dtInteger(_Data, sEnabled);
end;

procedure THiControlInfo._var_Cursor;
begin
  dtInteger(_Data, sCursor);  
end;

procedure THiControlInfo._var_AlphaBlendValue;
begin
  dtInteger(_Data, sAlphaBlendValue);  
end;

procedure THiControlInfo._var_Caption;
begin
  dtString(_Data, sCaption);  
end;

procedure THiControlInfo._var_SubClassName;
begin
  dtString(_Data, sSubClassName);   
end;

end.